/*
 * @Copyright © 2002-2018 Acronis International GmbH. All rights reserved
 */

define([
    'dojo/_base/declare',
    'dojox/mvc/at',
    'dojox/mvc/getStateful'
], function (
    declare,
    at,
    getStateful
) {
    return declare(null, {
        states: null,
        arrayValues: null,

        constructor: function(arrayValues) {
            var self = this, data = {};
            this.arrayValues = arrayValues;
            Object.values(arrayValues).map(function(key) {
                data[key] = arrayValues.indexOf(key) !== -1;
            });
            this.states = getStateful(data);

            // todo: implement watch external changes without triggering on normal checkbox switching
            // this.arrayValues.watch(function() {
            //     Object.values(self.arrayValues).map(function(key) {
            //         self.states.set(key, arrayValues.indexOf(key) !== -1);
            //     });
            // });
        },
        getCheckboxAt: function(key) {
            var self = this;
            return at(self.states, key).transform({
                parse: function (value) {
                    var keyOccurrenceIndex = self.arrayValues.indexOf(key);

                    if (!value && keyOccurrenceIndex !== -1) {
                        self.arrayValues.splice(keyOccurrenceIndex, 1);
                    }

                    if (value && keyOccurrenceIndex === -1) {
                        self.arrayValues.push(key);
                    }

                    return value;
                },
                format: function (value) {
                    return !!value;
                }
            });
        }
    });
});