/*
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

require([
    "aps/load",
    "./js/common.js",
    "./js/messages.js"
], function (
    load,
    common,
    messages
) {

    var tier = aps.context.vars.tier,
        minimalCommitmentsOutputs = tier.minimalCommitments ? tier.minimalCommitments.map(function (commitment) {
            return ["aps/Output", {
                id: common.genId('output'),
                label: commitment.currency,
                value: commitment.value
            }];
        }) : [],
        widgets = ["aps/PageContainer", {id: "apsPageContainer"}, [
            ["aps/FieldSet", {id: common.genId('fieldset'), title: _("General")}, [
                ["aps/Output", {
                    id: "name",
                    label: _("Minimum commitment tier name"),
                    value: tier.name
                }],
                ["aps/Output", {
                    id: "resourceType",
                    label: _("Resource"),
                    value: tier.resourceTypeId
                }],
                ["aps/Output", {
                    id: "level",
                    label: _("Level"),
                    value: common.getMinimalCommitmentLevelName(tier.level)
                }]
            ]],
            ["aps/FieldSet", {
                id: common.genId('fieldset'),
                title: _("Minimum commitments"),
                visible: tier.level >= 0
            }, minimalCommitmentsOutputs]
        ]];

    load(widgets).then(function () {
        aps.app.onSubmit = function () {
            aps.apsc.gotoView(common.getRelatedViewId('edit'), tier.aps.id);
        };
    }, messages.displayError);

    aps.app.onCancel = function () {
        aps.apsc.gotoView(common.getRelatedViewId('list'));
    };
});
