<?php
/**
 * @Copyright © 2002-2021 Acronis International GmbH. All rights reserved
 */

namespace Acronis\App\Folders;

use Acronis\App\Base\CompositeKeyInterface;
use Acronis\App\Base\GenericException;
use Acronis\App\Services\Cache\CacheAwareTrait;

/**
 * @Copyright © 2002-2020 Acronis International GmbH. All rights reserved
 */
class Cache implements \Acronis\App\Services\Cache\CacheInterface
{
    use CacheAwareTrait;

    /** @var string */
    private $keyPrefix = 'folder_';

    /**
     * Todo as soon as php 8 use Stringable as interface for key
     * @param \Acronis\App\Base\CompositeKeyInterface $key - just override on DOC level, no type hinting
     * @param mixed $value
     * @param null $ttl
     * @return mixed
     */
    public function set($key, $value, $ttl = null)
    {
        $this->getCache()->set($this->formatKey($key), $value);
    }

    public function delete($key)
    {
        // TODO: Implement delete() method.
    }

    public function deleteAll($prefix)
    {
        // TODO: Implement deleteAll() method.
    }

    /**
     * Todo as soon as php 8 use Stringable as interface for key
     * @param \Acronis\App\Base\CompositeKeyInterface $key - just override on DOC level, no type hinting
     * @param null $default
     * @return string
     */
    public function get($key, $default = null)
    {
        return $this->getCache()->get($this->formatKey($key), null);
    }

    private function formatKey(CompositeKeyInterface $key)
    {
        return $this->keyPrefix . (string) $key;
    }

    /**
     * @param string $key
     * @param int $ttl
     * @throws GenericException
     */
    public function refresh($key, $ttl)
    {
        throw new GenericException('Not implemented.');
    }

    /**
     * @param $key
     * @return bool|void
     * @throws GenericException
     */
    public function has($key)
    {
        throw new GenericException('Not implemented.');
    }
}