<?php
/**
 * @Copyright © 2002-2019 Acronis International GmbH. All rights reserved
 */

class Service_AmsApiClient_Request_PersonifiedLinks extends Service_BaseClient_Request_Base
{
    const REQUEST_URL = '/ams/links/personified_list';

    const EXCEPT_LINKS_NOT_FOUND = 'Links are not found.';
    const RESPONSE_200 = 200;

    public function __construct()
    {
        $this->_method = self::METHOD_GET;
        $this->_resource = self::REQUEST_URL;
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @throws Exception
     * @return string
     */
    public function getExpectedResponse($httpCode = null, $responseBody = null)
    {
        if (self::RESPONSE_200 != $httpCode) {
            throw new Exception(Str::format(
                self::EXCEPT_LINKS_NOT_FOUND,
                $this->_resource
            ));
        }
        return new Service_AmsApiClient_Response_PersonifiedLinks($responseBody);
    }
}