<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
 
class Service_MspApiClient_Response_MigrationGroup extends Service_BaseClient_Response_Base
{
    const ID = 'id';
    const NAME = 'name';
    const EXTERNAL = 'external';
    const PARENT_ID = 'parent_id';
    const KIND = 'kind';

    /** @var Service_MspApiClient_Response_Struct_FactoryInterface */
    private $_factory;

    /**
     * @param string|null $responseBody
     * @param Service_MspApiClient_Response_Struct_FactoryInterface $factory
     */
    public function __construct($responseBody = NULL, Service_MspApiClient_Response_Struct_FactoryInterface $factory = NULL)
    {
        $this->_factory = is_null($factory) ? new Service_MspApiClient_Response_Struct_Factory() : $factory;
        parent::__construct($responseBody);
    }

    /**
     * @param array $responseData
     * @return Service_MspApiClient_Response_Struct_MigrationGroup
     */
    protected function _init(array $responseData)
    {
        $migrationGroup = new Service_MspApiClient_Response_Struct_MigrationGroup();
        try
        {
            $migrationGroup->setId($responseData[self::ID]);
            $migrationGroup->setName($responseData[self::NAME]);
            $migrationGroup->setExternal($responseData[self::EXTERNAL]);
            $migrationGroup->setParentId($responseData[self::PARENT_ID]);
            $migrationGroup->setKind($responseData[self::KIND]);
        }
        catch (Exception $e)
        {
            Log::getInstance()->error($e->getMessage());
            return null;
        }

        return $migrationGroup;
    }
}