<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Request_ChangeExpiration extends Service_PbaApi_Client_Request
{
    const METHOD = 'ChangeExpiration';

    /**
     * @param int $subscriptionId
     * @param int $newExpDate
     * @param string $comment
     */
    public function __construct($subscriptionId, $newExpDate, $comment)
    {
        parent::__construct(self::METHOD, array(
            (int)$subscriptionId,
            (int)$newExpDate,
            (string)$comment
        ));
    }

    /**
     * Method returns status of changed subscription.
     *
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_ChangeExpiration
     */
    public function getExpectedResponse(array $responseArray = null)
    {
        return new Service_PbaApi_Api_Response_ChangeExpiration($responseArray);
    }
}
