<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Request_UpdateObjAttrList extends Service_PbaApi_Client_Request
{
    const METHOD = 'UpdateObjAttrList_API';

    /**
     * Service_PbaApi_Api_Request_GetAccountListByCustomAttribute constructor.
     * @param int $attributeType
     * @param int $objId
     * @param Service_PbaApi_Api_Request_Struct_UpdateObjAttrItem[] $attributeToUpdate
     */
    public function __construct($attributeType, $objId, array $attributeToUpdate)
    {
        $parameters = array((int)$attributeType, (int)$objId);
        foreach ($attributeToUpdate as $item) {
            $parameters[] = $item->getId();
            $parameters[] = $item->getValue();
        }
        parent::__construct(self::METHOD, $parameters);
    }

    /**
     * Method returns details of specified subscription.
     *
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_UpdateObjAttrList
     */
    public function getExpectedResponse(array $responseArray = null)
    {
        return new Service_PbaApi_Api_Response_UpdateObjAttrList($responseArray);
    }
}
