<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_GetOrderDetail extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        /**
        callee=BM::GetOrderDetail(OrdDetDetID)
        return=
            OrderID
            OrdDetDetTypeID
            OrdDetServQty
            OrdDetServUnitMeasure
            OrdDetUnitPrice
            TaxCategoryTaxCatID
            OrdDetDescr
            OrderDetailLineIsEditable
            OrdDetSKU
         */
        $data = $this->_getProperty(0, $responseArray);

        $detail = new Service_PbaApi_Api_Response_Struct_OrderDetail();
        $detail->setOrderId($this->_getProperty(0, $data));
        $detail->setDetailTypeId($this->_getProperty(1, $data));
        $detail->setServiceQuantity($this->_getProperty(2, $data));
        $detail->setServiceUnitMeasure($this->_getProperty(3, $data));
        $detail->setUnitPrice($this->_getProperty(4, $data));
        $detail->setTaxCategoryId($this->_getProperty(5, $data));
        $detail->setDescription($this->_getProperty(6, $data));
        $detail->setOrderDetailLineIsEditable($this->_getProperty(7, $data));
        $detail->setSKU($this->_getProperty(8, $data));

        return $detail;
    }
}
