<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_GetPlanCategoryList extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result for operation GetPlanCategoryList';

    /**
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_Struct_PlanCategoryListItemInterface[]
     * @throws Service_PbaApi_Client_InvalidPropertyException
     */
    protected function _init(array $responseArray = NULL)
    {
        if (is_null($responseArray))
        {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $list = array();
        $listData = $this->_getProperty(0, $responseArray);
        foreach($listData as $itemData)
        {
            $item = new Service_PbaApi_Api_Response_Struct_PlanCategoryListItem();
            $item->setPlanCategoryId($this->_getProperty(0, $itemData));
            $item->setName($this->_getProperty(1, $itemData));
            $item->setDescription($this->_getProperty(2, $itemData));

            $list[] = $item;
        }
        return $list;
    }
}
