<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_GetPlanPeriod extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        /**
        BM::PlanPeriodGet(PlanPeriodID)
        return=
            PlanPeriodID
            PlanPlanID
            Enabled
            Period
            PeriodType
            Trial
            AutoRenew_PlanPeriodID
            NumberOfPeriods
            SetupFee
            SetupFeeText
            ShowZeroSetupFee
            SubscriptionFee
            SubscriptionFeeText
            ShowZeroSubscriptionFee
            RenewalFee
            RenewalFeeText
            ShowZeroRenewalFee
            TransferFee
            TransferFeeText
            ShowZeroTransferFee
            DepositFee
            DepositFeeText
            ShowZeroDepositFee
            CancellationFeeType
            CancellationFeeFormula
            CancellationFeeText
            ShowZeroCancelFee
            NonRefundableAmt
            RefundPeriod
            RefundPolicy
            PlanNotifScheduleScheduleID
            NotifScheduleScheduleID
            FeeText
            SortNumber
            SetupSKUskuID
            SubscriptionSKUskuID
            RenewalSKUskuID
            TransferSKUskuID
            CancellationSKUskuID
         */
        $data = $this->_getProperty(0, $responseArray);

        $detail = new Service_PbaApi_Api_Response_Struct_PlanPeriod();
        $detail->setPeriodId($this->_getProperty(0, $data));
        $detail->setPlanId($this->_getProperty(1, $data));
        $detail->setEnabled($this->_getProperty(2, $data));
        $detail->setPeriod($this->_getProperty(3, $data));
        $detail->setPeriodType($this->_getProperty(4, $data));
        $detail->setTrial($this->_getProperty(5, $data));

        return $detail;
    }
}
