<?php
/**
 * @Copyright © 2002-2018 Acronis International GmbH. All rights reserved
 */

namespace Acronis\App\Services\OssApi;

use Acronis\App\Services\Config\ConfigAwareTrait;
use Acronis\App\Services\FactoryInterface;
use Service_OpenApi_Api;
use Service_OpenApi_ApiInterface;
use Service_OpenApi_Client;

class OssApiFactory implements FactoryInterface
{
    const NAME = 'oss_api';

    /**
     * @return Service_OpenApi_ApiInterface
     * @throws \Exception
     */
    public function createInstance()
    {
        $client = new Service_OpenApi_Client($this->getOssApiUrl());
        return new Service_OpenApi_Api($client);
    }

    /**
     * @return string
     * @throws \Exception
     */
    protected function getOssApiUrl()
    {
        return defined('OPEN_API_URI') ? OPEN_API_URI : parse_url(\APS\Proto::getControllerURI(), PHP_URL_HOST);
    }
}