<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

interface Cache_StoreInterface
{
    /**
     * @param string $cachePrefix
     */
    public function setCachePrefix($cachePrefix);

    /**
     * @return string
     */
    public function getCachePrefix();

    /**
     * @param string $key
     * @return string
     */
    public function getCacheUniqueKey($key);

    /**
     * Gets value from cache
     *
     * @param string $key
     * @return mixed
     */
    public function getValue($key);

    /**
     * Delete value from cache
     *
     * @param string $key
     */
    public function unsetValue($key);

    /**
     * Singleton implementation
     *
     * @return Cache_Store object
     */
    public static function getInstance();

    /**
     * Sets value to cache
     *
     * @param string $key
     * @param mixed $value
     */
    public function setValue($key, $value);
}