<?php
/**
 * @Copyright © 2002-2020 Acronis International GmbH. All rights reserved
 */

use Acronis\App\Console\Command\LockableTrait;
use Acronis\App\Services\CountersManager\CountersManagerAwareTrait;

require_once(__DIR__ . '/app/bootstrap.php');

/**
 * Class tenant
 * @type("http://acronis.com/aps/cloud-backup-v1/tenant/9.8")
 * @implements("http://aps-standard.org/types/core/resource/1.0")
 * @implements("http://aps-standard.org/types/core/suspendable/1.0")
 * @implements("http://aps-standard.org/types/core/subscription/service/1.0")
 */
class tenant extends APSResource
{
    use CountersManagerAwareTrait;
    use LockableTrait;

    const STORAGE_USAGE = 'StorageUsage';
    const LOCAL_STORAGE_USAGE = 'LocalStorageUsage';
    const STORAGE_USAGE_MBH = 'StorageUsageMbH';
    const ACRONIS_STORAGE_USAGE = 'AcronisHostedStorage';
    const ACRONIS_STORAGE_USAGE_MBH = 'AcronisHostedStorageMbH';
    const PROVIDER_STORAGE_USAGE = 'ServiceProviderHostedStorage';
    const PROVIDER_STORAGE_USAGE_MBH = 'ServiceProviderHostedStorageMbH';
    const GOOGLE_STORAGE_USAGE = 'GoogleHostedStorage';
    const AZURE_STORAGE_USAGE = 'AzureHostedStorage';
    const WORKSTATION_COUNT = 'WorkstationCount';
    const WORKSTATION_COUNT_ITEM = 'WorkstationCountItemH';
    const SERVER_COUNT = 'ServerCount';
    const SERVER_COUNT_ITEMH = 'ServerCountItemH';
    const VM_COUNT = 'VmCount';
    const VM_COUNT_ITEMH = 'VmCountItemH';
    const MOBILE_DEVICE_COUNT = 'MobileDeviceCount';
    const MOBILE_DEVICE_COUNT_ITEM = 'MobileDeviceCountItemH';
    const MAILBOX_COUNT = 'MailboxCount';
    const MAILBOX_COUNT_ITEMH = 'MailboxCountItemH';
    const WEBSITE_COUNT = 'WebsiteCount';
    const ADV_SERVICE_PROVIDER_HOSTED_STORAGE = 'AdvServiceProviderHostedStorage';
    const ADV_GSUITE_GOOGLE_DRIVE = 'AdvGsuiteGoogleDrive';
    const ADV_GSUITE_GOOGLE_MAIL = 'AdvGsuiteGoogleMail';
    const ADV_GSUITE_GOOGLE_TEAM_DRIVE = 'AdvGsuiteGoogleTeamDrive';
    const ADV_GSUITE_SEATS_COUNT = 'AdvGsuiteSeatsCount';
    const ADV_O365_SEATS_COUNT = 'AdvO365SeatsCount';
    const ADV_MOBILE_DEVICE_COUNT = 'AdvMobileDeviceCount';
    const ADV_ACRONIS_HOSTED_STORAGE = 'AdvAcronisHostedStorage';
    const ADV_AZURE_HOSTED_STORAGE = 'AdvAzureHostedStorage';
    const ADV_GOOGLE_HOSTED_STORAGE = 'AdvGoogleHostedStorage';
    const ADV_O365_MAILBOXES = 'AdvO365Mailboxes';
    const ADV_O365_ONE_DRIVE = 'AdvO365OneDrive';
    const ADV_O365_SHARE_POINT_SITES_COUNT = 'AdvO365SharePointSitesCount';
    const ADV_SERVER_COUNT = 'AdvServerCount';
    const ADV_STORAGE_USAGE = 'AdvStorageUsage';
    const ADV_VM_COUNT = 'AdvVmCount';
    const ADV_WEB_HOSTING_SERVER_COUNT = 'AdvWebHostingServerCount';
    const ADV_WEBSITE_COUNT = 'AdvWebsiteCount';
    const ADV_WORKSTATION_COUNT = 'AdvWorkstationCount';
    const P_ADV_PARTNER_HOSTED_STORAGE = 'PAdvPartnerHostedStorage';
    const P_ADV_GSUITE_GOOGLE_DRIVE = 'PAdvGsuiteGoogleDrive';
    const P_ADV_GSUITE_GOOGLE_MAIL = 'PAdvGsuiteGoogleMail';
    const P_ADV_GSUITE_GOOGLE_TEAM_DRIVE = 'PAdvGsuiteGoogleTeamDrive';
    const P_ADV_GSUITE_SEATS_COUNT = 'PAdvGsuiteSeatsCount';
    const P_ADV_O365_SEATS_COUNT = 'PAdvO365SeatsCount';
    const P_ADV_MOBILE_DEVICE_COUNT = 'PAdvMobileDeviceCount';
    const P_ADV_ACRONIS_HOSTED_STORAGE = 'PAdvAcronisHostedStorage';
    const P_ADV_AZURE_HOSTED_STORAGE = 'PAdvAzureHostedStorage';
    const P_ADV_GOOGLE_HOSTED_STORAGE = 'PAdvGoogleHostedStorage';
    const P_ADV_O365_MAILBOXES = 'PAdvO365Mailboxes';
    const P_ADV_O365_ONE_DRIVE = 'PAdvO365OneDrive';
    const P_ADV_O365_SHARE_POINT_SITES_COUNT = 'PAdvO365SharePointSitesCount';
    const P_ADV_SERVER_COUNT = 'PAdvServerCount';
    const P_ADV_STORAGE_USAGE = 'PAdvStorageUsage';
    const P_ADV_VM_COUNT = 'PAdvVmCount';
    const P_ADV_WEB_HOSTING_SERVER_COUNT = 'PAdvWebHostingServerCount';
    const P_ADV_WEBSITE_COUNT = 'PAdvWebsiteCount';
    const P_ADV_WORKSTATION_COUNT = 'PAdvWorkstationCount';
    const P_DRE_PARTNER_HOSTED_STORAGE = 'PDrePartnerHostedStorage';
    const P_DRE_COMPUTE_POINTS_COUNT = 'PDreComputePointsCount';
    const P_DRE_DR_PARTNER_HOSTED_STORAGE = 'PDreDrPartnerHostedStorage';
    const P_DRE_CLOUD_SERVERS_COUNT = 'PDreCloudServersCount';
    const P_DRE_INTERNET_ACCESS = 'PDreInternetAccess';
    const P_DRE_DR_STORAGE_USAGE = 'PDreDrStorageUsage';
    const P_DRE_GSUITE_GOOGLE_DRIVE = 'PDreGsuiteGoogleDrive';
    const P_DRE_GSUITE_GOOGLE_MAIL = 'PDreGsuiteGoogleMail';
    const P_DRE_GSUITE_GOOGLE_TEAM_DRIVE = 'PDreGsuiteGoogleTeamDrive';
    const P_DRE_GSUITE_SEATS_COUNT = 'PDreGsuiteSeatsCount';
    const P_DRE_O365_SEATS_COUNT = 'PDreO365SeatsCount';
    const P_DRE_MOBILE_DEVICE_COUNT = 'PDreMobileDeviceCount';
    const P_DRE_DR_ACRONIS_HOSTED_STORAGE = 'PDreDrAcronisHostedStorage';
    const P_DRE_GOOGLE_HOSTED_STORAGE = 'PDreGoogleHostedStorage';
    const P_DRE_AZURE_HOSTED_STORAGE = 'PDreAzureHostedStorage';
    const P_DRE_ACRONIS_HOSTED_STORAGE = 'PDreAcronisHostedStorage';
    const P_DRE_O365_MAILBOXES = 'PDreO365Mailboxes';
    const P_DRE_O365_ONE_DRIVE = 'PDreO365OneDrive';
    const P_DRE_O365_SHARE_POINT_SITES_COUNT = 'PDreO365SharePointSitesCount';
    const P_DRE_PUBLIC_IPS_COUNT = 'PDrePublicIpsCount';
    const P_DRE_SERVER_COUNT = 'PDreServerCount';
    const P_DRE_STORAGE_USAGE = 'PDreStorageUsage';
    const P_DRE_VM_COUNT = 'PDreVmCount';
    const P_DRE_WEB_HOSTING_SERVER_COUNT = 'PDreWebHostingServerCount';
    const P_DRE_WEBSITE_COUNT = 'PDreWebsiteCount';
    const P_DRE_WORKSTATION_COUNT = 'PDreWorkstationCount';
    const P_PARTNER_HOSTED_STORAGE = 'PPartnerHostedStorage';
    const P_GSUITE_GOOGLE_DRIVE = 'PGsuiteGoogleDrive';
    const P_GSUITE_GOOGLE_MAIL = 'PGsuiteGoogleMail';
    const P_GSUITE_GOOGLE_TEAM_DRIVE = 'PGsuiteGoogleTeamDrive';
    const P_GSUITE_SEATS_COUNT = 'PGsuiteSeatsCount';
    const PO365_SEATS_COUNT = 'PO365SeatsCount';
    const P_MOBILE_DEVICE_COUNT = 'PMobileDeviceCount';
    const P_GOOGLE_HOSTED_STORAGE = 'PGoogleHostedStorage';
    const P_AZURE_HOSTED_STORAGE = 'PAzureHostedStorage';
    const P_ACRONIS_HOSTED_STORAGE = 'PAcronisHostedStorage';
    const PO365_MAILBOXES = 'PO365Mailboxes';
    const PO365_ONE_DRIVE = 'PO365OneDrive';
    const PO365_SHARE_POINT_SITES_COUNT = 'PO365SharePointSitesCount';
    const P_SERVER_COUNT = 'PServerCount';
    const P_STORAGE_USAGE = 'PStorageUsage';
    const P_VM_COUNT = 'PVmCount';
    const P_WEB_HOSTING_SERVER_COUNT = 'PWebHostingServerCount';
    const P_WEBSITE_COUNT = 'PWebsiteCount';
    const P_WORKSTATION_COUNT = 'PWorkstationCount';
    const DRE_SERVICE_PROVIDER_HOSTED_STORAGE = 'DreServiceProviderHostedStorage';
    const DRE_COMPUTE_POINTS_COUNT = 'DreComputePointsCount';
    const DRE_DR_PARTNER_HOSTED_STORAGE = 'DreDRPartnerHostedStorage';
    const DRE_CLOUD_SERVERS_COUNT = 'DreCloudServersCount';
    const DRE_INTERNET_ACCESS = 'DreInternetAccess';
    const DRE_DR_STORAGE_USAGE = 'DreDrStorageUsage';
    const DRE_GSUITE_GOOGLE_DRIVE = 'DreGsuiteGoogleDrive';
    const DRE_GSUITE_GOOGLE_MAIL = 'DreGsuiteGoogleMail';
    const DRE_GSUITE_GOOGLE_TEAM_DRIVE = 'DreGsuiteGoogleTeamDrive';
    const DRE_GSUITE_SEATS_COUNT = 'DreGsuiteSeatsCount';
    const DRE_O365_SEATS_COUNT = 'DreO365SeatsCount';
    const DRE_MOBILE_DEVICE_COUNT = 'DreMobileDeviceCount';
    const DRE_DR_ACRONIS_HOSTED_STORAGE = 'DreDRAcronisHostedStorage';
    const DRE_GOOGLE_HOSTED_STORAGE = 'DreGoogleHostedStorage';
    const DRE_AZURE_HOSTED_STORAGE = 'DreAzureHostedStorage';
    const DRE_ACRONIS_HOSTED_STORAGE = 'DreAcronisHostedStorage';
    const DRE_O365_MAILBOXES = 'DreO365Mailboxes';
    const DRE_O365_ONE_DRIVE = 'DreO365OneDrive';
    const DRE_O365_SHARE_POINT_SITES_COUNT = 'DreO365SharePointSitesCount';
    const DRE_PUBLIC_I_PS_COUNT = 'DrePublicIPsCount';
    const DRE_SERVER_COUNT = 'DreServerCount';
    const DRE_STORAGE_USAGE = 'DreStorageUsage';
    const DRE_VM_COUNT = 'DreVmCount';
    const DRE_WEB_HOSTING_SERVER_COUNT = 'DreWebHostingServerCount';
    const DRE_WEBSITE_COUNT = 'DreWebsiteCount';
    const DRE_WORKSTATION_COUNT = 'DreWorkstationCount';
    const DR_ACRONIS_HOSTED_STORAGE = 'DRAcronisHostedStorage';
    const DR_PARTNER_HOSTED_STORAGE = 'DRPartnerHostedStorage';
    const GSUITE_SEATS_COUNT = 'GsuiteSeatsCount';
    const GSUITE_GOOGLE_TEAM_DRIVE = 'GsuiteGoogleTeamDrive';
    const GSUITE_GOOGLE_MAIL = 'GsuiteGoogleMail';
    const GSUITE_GOOGLE_DRIVE = 'GsuiteGoogleDrive';
    const ADV_O365_TEAMS_COUNT = 'AdvO365TeamsCount';
    const P_ADV_O365_TEAMS_COUNT = 'PAdvO365TeamsCount';
    const P_DRE_O365_TEAMS_COUNT = 'PDreO365TeamsCount';
    const PO365_TEAMS_COUNT = 'PO365TeamsCount';
    const DRE_O365_TEAMS_COUNT = 'DreO365TeamsCount';
    const O365_TEAMS_COUNT = 'O365TeamsCount';
    const WEB_HOSTING_SERVER_COUNT = 'WebHostingServerCount';

    const MAILBOX_INSTANCE_SIZE = 'MailboxInstanceSize';

    const O365_MAILBOXES = 'O365Mailboxes';
    const O365_ONE_DRIVE = 'O365OneDrive';
    const O365_SHARE_POINT_SITES_COUNT = 'O365SharePointSitesCount';

    const DR_STORAGE_USAGE = 'DrStorageUsage';
    const DR_COMPUTE_POINTS_COUNT = 'ComputePointsCount';
    const DR_PUBLIC_IPS_COUNT = 'PublicIPsCount';
    const DR_CLOUD_SERVERS_COUNT = 'CloudServersCount';
    const DR_INTERNET_ACCESS = 'InternetAccess';

    const UNLIMITED_VALUE = -1;

    const ON_USER_CHANGED = 'onUserChanged';
    const ON_ACCOUNT_CHANGE = 'onAccountChange';
    const ON_SUBSCRIPTION_CHANGE = 'onSubscriptionChange';
    const ON_TENANT_AVAILABLE = "onTenantAvailable";

    const LOG_CALLED_UPDATE_COUNTER_LIMITS = 'Update counter limits for tenant was called.';
    const LOG_CALLED_GET_PARTNER_CREDENTIALS = 'Get partner credentials for tenant was called.';
    const LOG_CALLED_UPGRADE = 'Tenant (%s) upgrade was called';
    const LOG_CALLED_LINK_DATACENTER = 'Tenant (%s) link datacenter was called';
    const LOG_EVENT_START_OPERATION = "Start %s: %s %s body: %s.";
    const LOG_EVENT_FINISH_OPERATION = "Finish %s: %s %s body: %s.";

    const OPERATION_PROVISION_RESOURCE = "provisionResource";
    const OPERATION_CONFIGURE_RESOURCE = "configureResource";

    const APS_2_2_RESOURCES = '/aps/2.2/resources/';

    const ERROR_FAILED_LOCK_GROUP = 'Failed to lock group id: %s';

    const EXCEPTION_CREATING_TENANT_MESSAGE = 'Creating tenant (%s) for subscription (%s)';
    const EXCEPTION_MORE_THAN_1_COMMITMENT_MESSAGE = 'Only one minimum commitment resource can be included into a service plan.';
    const EXCEPTION_RESOURCE_TYPE_MUST_BE_REFERENCE_MESSAGE = 'Resource type "%s" must be a reference.';
    const EXCEPTION_UNSUPPORTED_OPERATION_MESSAGE = "Unsupported action: %s.";

    const LINK_NAME_PROFILE = 'profile';
    const LINK_NAME_DATACENTER = 'datacenter';

    const TYPE_RESELLER = 'RESELLER';
    const TYPE_CUSTOMER = 'CUSTOMER';
    const TYPE_PARTNER = 'PARTNER';

    const SUPPORTED_TENANT_TYPES = [
        self::TYPE_CUSTOMER,
        self::TYPE_PARTNER,
        self::TYPE_RESELLER
    ];

    const LOG_METHOD_CALL = 'Resource: %s Account: %s Subscription: %s Call: %s';

    /* ======= RESOURCE PROPERTIES ======= */

    /**
     * @type(string)
     * @readonly
     */
    public $tenantId;

    /**
     * @link("http://acronis.com/aps/cloud-backup-v1/globals/9.0")
     * @required
     */
    public $global;

    /**
     * @link("http://aps-standard.org/types/core/subscription/1.0")
     * @required
     */
    public $subscription;

    /**
     * @link("http://aps-standard.org/types/core/account/1.0")
     * @required
     */
    public $account;

    /**
     * @link("http://acronis.com/aps/cloud-backup-v1/users/7.0[]")
     */
    public $users;

    /**
     * @link("http://acronis.com/aps/cloud-backup-v1/admin/4.0[]")
     * @deprecated
     */
    public $admins;

    /**
     * @link("http://acronis.com/aps/cloud-backup-v1/backup-profile/5.0")
     */
    public $profile;

    /**
     * @link("http://acronis.com/aps/cloud-backup-v1/datacenter/4.0")
     */
    public $datacenter;

    /**
     * @link("http://acronis.com/aps/cloud-backup-v1/minimal-commitment-tier/4.0")
     */
    public $minimalCommitmentTier;

    /**
     * @type(integer)
     * @readonly
     */
    public $minimalCommitmentDiscountId;

    /**
     * @type(integer)
     * @readonly
     */
    public $startProductionTime;

    /**
     * @link("http://aps-standard.org/types/core/admin-user/1.0[]");
     * @deprecated
     */
    public $adminusers;

    /**
     * @type(integer)
     * @title("Account ID")
     * @readonly
     */
    public $accountId;

    /**
     * @type(string)
     * @title("Subscription ID")
     * @readonly
     */
    public $subscriptionId;

    /**
     * @type(StorageRelation[])
     */
    public $storageRelations = array();

    /**
     * @type(string)
     */
    public $datacenterId;

    /**
     * deprecated
     * @type(integer)
     */
    public $storageId;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Storage size for customer")
     * @unit("b")
     */
    public $StorageUsage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Local storage")
     * @unit("b")
     */
    public $LocalStorageUsage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Own Cloud Storage usage")
     * @unit("b")
     */
    public $AcronisHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Service Provider Cloud Storage usage")
     * @unit("b")
     */
    public $ServiceProviderHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV Reseller's Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $AdvServiceProviderHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV Google Drive (Acronis)")
     * @unit("unit")
     */
    public $AdvGsuiteGoogleDrive;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV Gmail (incl. Calendar, Contacts) (Acronis)")
     * @unit("unit")
     */
    public $AdvGsuiteGoogleMail;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV G Suite Shared Drive (Acronis)")
     * @unit("unit")
     */
    public $AdvGsuiteGoogleTeamDrive;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV G Suite seats (Acronis)")
     * @unit("unit")
     */
    public $AdvGsuiteSeatsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV Protected Microsoft 365 seats (Acronis)")
     * @unit("unit")
     */
    public $AdvO365SeatsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV Protected Mobile Devices (Acronis)")
     * @unit("unit")
     */
    public $AdvMobileDeviceCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV Provider's Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $AdvAcronisHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV Microsoft Azure Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $AdvAzureHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV Google Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $AdvGoogleHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV Microsoft 365 Mailboxes (Acronis)")
     * @unit("unit")
     */
    public $AdvO365Mailboxes;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV Microsoft 365 OneDrive (Acronis)")
     * @unit("unit")
     */
    public $AdvO365OneDrive;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV Microsoft SharePoint Online sites (Acronis)")
     * @unit("unit")
     */
    public $AdvO365SharePointSitesCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV Protected Servers (Acronis)")
     * @unit("unit")
     */
    public $AdvServerCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV Cloud Storage (Acronis)")
     * @unit("b")
     */
    public $AdvStorageUsage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV Protected Virtual Machines (Acronis)")
     * @unit("unit")
     */
    public $AdvVmCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV Protected Web Hosting Servers (Acronis)")
     * @unit("unit")
     */
    public $AdvWebHostingServerCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV Protected Websites (Acronis)")
     * @unit("unit")
     */
    public $AdvWebsiteCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV Protected Workstations (Acronis)")
     * @unit("unit")
     */
    public $AdvWorkstationCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV Reseller's Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $PAdvPartnerHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV Google Drive (Acronis)")
     * @unit("unit")
     */
    public $PAdvGsuiteGoogleDrive;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV Gmail (incl. Calendar, Contacts) (Acronis)")
     * @unit("unit")
     */
    public $PAdvGsuiteGoogleMail;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV G Suite Shared Drive (Acronis)")
     * @unit("unit")
     */
    public $PAdvGsuiteGoogleTeamDrive;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV G Suite seats (Acronis)")
     * @unit("unit")
     */
    public $PAdvGsuiteSeatsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV Protected Microsoft 365 seats (Acronis)")
     * @unit("unit")
     */
    public $PAdvO365SeatsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV Protected Mobile Devices (Acronis)")
     * @unit("unit")
     */
    public $PAdvMobileDeviceCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV Provider's Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $PAdvAcronisHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV Microsoft Azure Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $PAdvAzureHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV Google Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $PAdvGoogleHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV Microsoft 365 Mailboxes (Acronis)")
     * @unit("unit")
     */
    public $PAdvO365Mailboxes;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV Microsoft 365 OneDrive (Acronis)")
     * @unit("unit")
     */
    public $PAdvO365OneDrive;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV Microsoft SharePoint Online sites (Acronis)")
     * @unit("unit")
     */
    public $PAdvO365SharePointSitesCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV Protected Servers (Acronis)")
     * @unit("unit")
     */
    public $PAdvServerCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV Cloud Storage (Acronis)")
     * @unit("b")
     */
    public $PAdvStorageUsage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV Protected Virtual Machines (Acronis)")
     * @unit("unit")
     */
    public $PAdvVmCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV Protected Web Hosting Servers (Acronis)")
     * @unit("unit")
     */
    public $PAdvWebHostingServerCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV Protected Websites (Acronis)")
     * @unit("unit")
     */
    public $PAdvWebsiteCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV Protected Workstations (Acronis)")
     * @unit("unit")
     */
    public $PAdvWorkstationCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Reseller's Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $PDrePartnerHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Compute Points (Acronis)")
     * @unit("item-h")
     */
    public $PDreComputePointsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Disaster Recovery Storage Partner Hosted (Acronis)")
     * @unit("b")
     */
    public $PDreDrPartnerHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Cloud Servers (Acronis)")
     * @unit("unit")
     */
    public $PDreCloudServersCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Internet access (Acronis)")
     * @unit("unit")
     */
    public $PDreInternetAccess;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Disaster Recovery Storage (Acronis)")
     * @unit("b")
     */
    public $PDreDrStorageUsage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Google Drive (Acronis)")
     * @unit("unit")
     */
    public $PDreGsuiteGoogleDrive;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Gmail (incl. Calendar, Contacts) (Acronis)")
     * @unit("unit")
     */
    public $PDreGsuiteGoogleMail;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE G Suite Shared Drive (Acronis)")
     * @unit("unit")
     */
    public $PDreGsuiteGoogleTeamDrive;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE G Suite seats (Acronis)")
     * @unit("unit")
     */
    public $PDreGsuiteSeatsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Protected Microsoft 365 seats (Acronis)")
     * @unit("unit")
     */
    public $PDreO365SeatsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Protected Mobile Devices (Acronis)")
     * @unit("unit")
     */
    public $PDreMobileDeviceCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Disaster Recovery Storage Acronis Hosted (Acronis)")
     * @unit("b")
     */
    public $PDreDrAcronisHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Google Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $PDreGoogleHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Microsoft Azure Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $PDreAzureHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Provider's Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $PDreAcronisHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Microsoft 365 Mailboxes (Acronis)")
     * @unit("unit")
     */
    public $PDreO365Mailboxes;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Microsoft 365 OneDrive (Acronis)")
     * @unit("unit")
     */
    public $PDreO365OneDrive;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Microsoft SharePoint Online sites (Acronis)")
     * @unit("unit")
     */
    public $PDreO365SharePointSitesCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Public IP addresses (Acronis)")
     * @unit("unit")
     */
    public $PDrePublicIpsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Protected Servers (Acronis)")
     * @unit("unit")
     */
    public $PDreServerCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Cloud Storage (Acronis)")
     * @unit("b")
     */
    public $PDreStorageUsage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Protected Virtual Machines (Acronis)")
     * @unit("unit")
     */
    public $PDreVmCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Protected Web Hosting Servers (Acronis)")
     * @unit("unit")
     */
    public $PDreWebHostingServerCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Protected Websites (Acronis)")
     * @unit("unit")
     */
    public $PDreWebsiteCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Protected Workstations (Acronis)")
     * @unit("unit")
     */
    public $PDreWorkstationCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD Reseller's Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $PPartnerHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD Google Drive (Acronis)")
     * @unit("unit")
     */
    public $PGsuiteGoogleDrive;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD Gmail (incl. Calendar, Contacts) (Acronis)")
     * @unit("unit")
     */
    public $PGsuiteGoogleMail;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD G Suite Shared Drive (Acronis)")
     * @unit("unit")
     */
    public $PGsuiteGoogleTeamDrive;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD G Suite seats (Acronis)")
     * @unit("unit")
     */
    public $PGsuiteSeatsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD Protected Microsoft 365 seats (Acronis)")
     * @unit("unit")
     */
    public $PO365SeatsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD Protected Mobile Devices (Acronis)")
     * @unit("unit")
     */
    public $PMobileDeviceCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD Google Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $PGoogleHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD Microsoft Azure Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $PAzureHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD Provider's Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $PAcronisHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD Microsoft 365 Mailboxes (Acronis)")
     * @unit("unit")
     */
    public $PO365Mailboxes;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD Microsoft 365 OneDrive (Acronis)")
     * @unit("unit")
     */
    public $PO365OneDrive;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD Microsoft SharePoint Online sites (Acronis)")
     * @unit("unit")
     */
    public $PO365SharePointSitesCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD Protected Servers (Acronis)")
     * @unit("unit")
     */
    public $PServerCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD Cloud Storage (Acronis)")
     * @unit("b")
     */
    public $PStorageUsage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD Protected Virtual Machines (Acronis)")
     * @unit("unit")
     */
    public $PVmCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD Protected Web Hosting Servers (Acronis)")
     * @unit("unit")
     */
    public $PWebHostingServerCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD Protected Websites (Acronis)")
     * @unit("unit")
     */
    public $PWebsiteCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD Protected Workstations (Acronis)")
     * @unit("unit")
     */
    public $PWorkstationCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Reseller's Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $DreServiceProviderHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Compute Points (Acronis)")
     * @unit("item-h")
     */
    public $DreComputePointsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Disaster Recovery Storage Partner Hosted (Acronis)")
     * @unit("b")
     */
    public $DreDRPartnerHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Cloud Servers (Acronis)")
     * @unit("unit")
     */
    public $DreCloudServersCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Internet access (Acronis)")
     * @unit("unit")
     */
    public $DreInternetAccess;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Disaster Recovery Storage (Acronis)")
     * @unit("b")
     */
    public $DreDrStorageUsage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Google Drive (Acronis)")
     * @unit("unit")
     */
    public $DreGsuiteGoogleDrive;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Gmail (incl. Calendar, Contacts) (Acronis)")
     * @unit("unit")
     */
    public $DreGsuiteGoogleMail;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE G Suite Shared Drive (Acronis)")
     * @unit("unit")
     */
    public $DreGsuiteGoogleTeamDrive;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE G Suite seats (Acronis)")
     * @unit("unit")
     */
    public $DreGsuiteSeatsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Protected Microsoft 365 seats (Acronis)")
     * @unit("unit")
     */
    public $DreO365SeatsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Protected Mobile Devices (Acronis)")
     * @unit("unit")
     */
    public $DreMobileDeviceCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Disaster Recovery Storage Acronis Hosted (Acronis)")
     * @unit("b")
     */
    public $DreDRAcronisHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Google Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $DreGoogleHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Microsoft Azure Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $DreAzureHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Provider's Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $DreAcronisHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Microsoft 365 Mailboxes (Acronis)")
     * @unit("unit")
     */
    public $DreO365Mailboxes;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Microsoft 365 OneDrive (Acronis)")
     * @unit("unit")
     */
    public $DreO365OneDrive;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Microsoft SharePoint Online sites (Acronis)")
     * @unit("unit")
     */
    public $DreO365SharePointSitesCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Public IP addresses (Acronis)")
     * @unit("unit")
     */
    public $DrePublicIPsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Protected Servers (Acronis)")
     * @unit("unit")
     */
    public $DreServerCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Cloud Storage (Acronis)")
     * @unit("b")
     */
    public $DreStorageUsage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Protected Virtual Machines (Acronis)")
     * @unit("unit")
     */
    public $DreVmCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Protected Web Hosting Servers (Acronis)")
     * @unit("unit")
     */
    public $DreWebHostingServerCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Protected Websites (Acronis)")
     * @unit("unit")
     */
    public $DreWebsiteCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Protected Workstations (Acronis)")
     * @unit("unit")
     */
    public $DreWorkstationCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Disaster Recovery Storage Acronis Hosted (Acronis)")
     * @unit("b")
     */
    public $DRAcronisHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Disaster Recovery Storage Partner Hosted (Acronis)")
     * @unit("b")
     */
    public $DRPartnerHostedStorage;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("G Suite seats (Acronis)")
     * @unit("unit")
     */
    public $GsuiteSeatsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("G Suite Shared Drive (Acronis)")
     * @unit("unit")
     */
    public $GsuiteGoogleTeamDrive;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Gmail (incl. Calendar, Contacts) (Acronis)")
     * @unit("unit")
     */
    public $GsuiteGoogleMail;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Google Drive (Acronis)")
     * @unit("unit")
     */
    public $GsuiteGoogleDrive;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("ADV Microsoft Teams (Acronis)")
     * @unit("unit")
     */
    public $AdvO365TeamsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT ADV Microsoft Teams (Acronis)")
     * @unit("unit")
     */
    public $PAdvO365TeamsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT DRE Microsoft Teams (Acronis)")
     * @unit("unit")
     */
    public $PDreO365TeamsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("PROTECT STD Microsoft Teams (Acronis)")
     * @unit("unit")
     */
    public $PO365TeamsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("DRE Microsoft Teams (Acronis)")
     * @unit("unit")
     */
    public $DreO365TeamsCount;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Microsoft Teams (Acronis)")
     * @unit("unit")
     */
    public $O365TeamsCount;

   /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Google Hosted Storage usage")
     * @unit("b")
     */
    public $GoogleHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Azure Hosted Storage usage")
     * @unit("b")
     */
    public $AzureHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Server count for customer")
     * @unit("unit")
     */
    public $ServerCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("VM count for customer")
     * @unit("unit")
     */
    public $VmCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Workstation count for customer")
     * @unit("unit")
     */
    public $WorkstationCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("The number of mobile devices")
     * @unit("unit")
     */
    public $MobileDeviceCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("The number of Windows servers essentials")
     * @unit("unit")
     * @deprecated
     */
    public $WindowsServerEssentialsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("The number of virtual hosts")
     * @unit("unit")
     * @deprecated
     */
    public $VirtualHostsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("The number of Mailbox")
     * @unit("unit")
     */
    public $MailboxCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Microsoft 365 Mailboxes")
     * @unit("unit")
     */
    public $O365Mailboxes;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Microsoft 365 OneDrive")
     * @unit("unit")
     */
    public $O365OneDrive;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("The number of Microsoft 365 SharePoint sites")
     * @unit("unit")
     */
    public $O365SharePointSitesCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("The number of web hosting servers")
     * @unit("unit")
     */
    public $WebHostingServerCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("The number of websites")
     * @unit("unit")
     */
    public $WebsiteCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Storage size for customer in hour")
     * @unit("mb-h")
     */
    public $StorageUsageMbH;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Own Cloud Storage usage in hour")
     * @unit("mb-h")
     */
    public $AcronisHostedStorageMbH;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Service Provider Cloud Storage usage in hour")
     * @unit("mb-h")
     */
    public $ServiceProviderHostedStorageMbH;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Server count for customer in hour")
     * @unit("item-h")
     */
    public $ServerCountItemH;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("VM count for customer in hour")
     * @unit("item-h")
     */
    public $VmCountItemH;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Workstation count for customer in hour")
     * @unit("item-h")
     */
    public $WorkstationCountItemH;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("The number of mobile devices in hour")
     * @unit("item-h")
     */
    public $MobileDeviceCountItemH;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("The number of Windows servers essentials in hour")
     * @unit("item-h")
     * @deprecated
     */
    public $WindowsServerEssentialsCountItemH;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("The number of virtual hosts in hour")
     * @unit("item-h")
     * @deprecated
     */
    public $VirtualHostsCountItemH;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("The number of Mailbox in hour")
     * @unit("item-h")
     */
    public $MailboxCountItemH;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Disaster recovery storage")
     * @unit("b")
     */
    public $DrStorageUsage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Compute points")
     * @unit("item-h")
     */
    public $ComputePointsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Public IP addresses")
     * @unit("unit")
     */
    public $PublicIPsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cloud servers")
     * @unit("unit")
     */
    public $CloudServersCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Internet access")
     * @unit("unit")
     */
    public $InternetAccess;
    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Files Cloud Storage (Acronis)")
     * @unit("b")
     */
    public $FilesStorageUsage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Files Cloud Storage Acronis Hosted (Acronis)")
     * @unit("b")
     */
    public $FCAcronisHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Files Cloud Storage Partner Hosted (Acronis)")
     * @unit("b")
     */
    public $FCPartnerHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Files Cloud Users (Acronis)")
     * @unit("unit")
     */
    public $FilesUsersCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Notary - Notarizations (Ethereum)")
     * @unit("item-h")
     */
    public $NotarizationsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Notary - eSignatures (Ethereum)")
     * @unit("item-h")
     */
    public $EsignaturesCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Files Cloud Notarizations (Ethereum)")
     * @unit("item-h")
     */
    public $FCNotarizationsEthereum;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Files Cloud eSignatures (Ethereum)")
     * @unit("item-h")
     */
    public $FCEsignaturesEthereum;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Notary - Notary storage")
     * @unit("b")
     */
    public $NotaryUsage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP BACKUP STD G Suite seats (Acronis)")
     * @unit("unit")
     */
    public $CPBStdGsuiteSeatsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP BACKUP STD G Suite Shared Drive (Acronis)")
     * @unit("unit")
     */
    public $CPBStdGsuiteGoogleTeamDrive;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP BACKUP STD Gmail (incl. Calendar, Contacts) (Acronis)")
     * @unit("unit")
     */
    public $CPBStdGsuiteGoogleMail;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP BACKUP STD Google Drive (Acronis)")
     * @unit("unit")
     */
    public $CPBStdGsuiteGoogleDrive;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP BACKUP STD Microsoft 365 Mailboxes (Acronis)")
     * @unit("unit")
     */
    public $CPBStdO365Mailboxes;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP BACKUP STD Microsoft 365 Seats (Acronis)")
     * @unit("unit")
     */
    public $CPBStdO365SeatsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP BACKUP STD Mobile Devices (Acronis)")
     * @unit("unit")
     */
    public $CPBStdMobileDeviceCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP BACKUP STD Microsoft SharePoint Online (Acronis)")
     * @unit("unit")
     */
    public $CPBStdO365SharePointSitesCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP BACKUP STD Microsoft Teams (Acronis)")
     * @unit("unit")
     */
    public $CPBStdO365TeamsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP BACKUP STD Microsoft OneDrive (Acronis)")
     * @unit("unit")
     */
    public $CPBStdO365OneDrive;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP BACKUP STD Servers (Acronis)")
     * @unit("unit")
     */
    public $CPBStdServerCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP BACKUP STD Virtual machines (Acronis)")
     * @unit("unit")
     */
    public $CPBStdVmCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP BACKUP STD Web hosting servers (Acronis)")
     * @unit("unit")
     */
    public $CPBStdWebHostingServerCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP BACKUP STD Websites (Acronis)")
     * @unit("unit")
     */
    public $CPBStdWebsiteCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP BACKUP STD Workstations (Acronis)")
     * @unit("unit")
     */
    public $CPBStdWorkstationCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP Disaster Recovery Cloud Servers (Acronis)")
     * @unit("unit")
     */
    public $CPCloudServersCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP Cloud Storage (Acronis)")
     * @unit("b")
     */
    public $CPStorageUsage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP Reseller's Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $CPServiceProviderHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP Provider's Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $CPAcronisHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP Google Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $CPGoogleHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP Microsoft Azure Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $CPAzureHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP Disaster Recovery Compute Points (Acronis)")
     * @unit("item-h")
     */
    public $CPComputePointsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP Disaster Recovery Storage (Acronis)")
     * @unit("b")
     */
    public $CPDrStorageUsage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP Disaster Recovery Storage Acronis Hosted (Acronis)")
     * @unit("b")
     */
    public $CPDRAcronisHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP Disaster Recovery Storage Partner Hosted (Acronis)")
     * @unit("b")
     */
    public $CPDRPartnerHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP Disaster Recovery Internet access (Acronis)")
     * @unit("unit")
     */
    public $CPInternetAccess;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP PROTECT ADV Servers (Acronis)")
     * @unit("unit")
     */
    public $CPPAdvServerCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP PROTECT ADV Virtual machines (Acronis)")
     * @unit("unit")
     */
    public $CPPAdvVmCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP PROTECT ADV Web hosting servers (Acronis)")
     * @unit("unit")
     */
    public $CPPAdvWebHostingServerCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP PROTECT ADV Workstations (Acronis)")
     * @unit("unit")
     */
    public $CPPAdvWorkstationCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP PROTECT ESS Servers (Acronis)")
     * @unit("unit")
     */
    public $CPPEssServerCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP PROTECT ESS Virtual machines (Acronis)")
     * @unit("unit")
     */
    public $CPPEssVmCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP PROTECT ESS Workstations (Acronis)")
     * @unit("unit")
     */
    public $CPPEssWorkstationCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP PROTECT STD Servers (Acronis)")
     * @unit("unit")
     */
    public $CPPStdServerCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP PROTECT STD Virtual machines (Acronis)")
     * @unit("unit")
     */
    public $CPPStdVmCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP PROTECT STD Web hosting servers (Acronis)")
     * @unit("unit")
     */
    public $CPPStdWebHostingServerCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP PROTECT STD Workstations (Acronis)")
     * @unit("unit")
     */
    public $CPPStdWorkstationCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CP Disaster Recovery Public IP addresses (Acronis)")
     * @unit("unit")
     */
    public $CPPublicIPsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB BACKUP STD G Suite seats (Acronis)")
     * @unit("unit")
     */
    public $CBBStdGsuiteSeatsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB BACKUP STD G Suite Shared Drive (Acronis)")
     * @unit("unit")
     */
    public $CBBStdGsuiteGoogleTeamDrive;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB BACKUP STD Gmail (incl. Calendar, Contacts) (Acronis)")
     * @unit("unit")
     */
    public $CBBStdGsuiteGoogleMail;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB BACKUP STD Google Drive (Acronis)")
     * @unit("unit")
     */
    public $CBBStdGsuiteGoogleDrive;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB BACKUP STD Microsoft 365 Mailboxes (Acronis)")
     * @unit("unit")
     */
    public $CBBStdO365Mailboxes;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB BACKUP STD Microsoft 365 Seats (Acronis)")
     * @unit("unit")
     */
    public $CBBStdO365SeatsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB BACKUP STD Microsoft SharePoint Online (Acronis)")
     * @unit("unit")
     */
    public $CBBStdO365SharePointSitesCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB BACKUP STD Microsoft Teams (Acronis)")
     * @unit("unit")
     */
    public $CBBStdO365TeamsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB BACKUP STD Mobile Devices (Acronis)")
     * @unit("unit")
     */
    public $CBBStdMobileDeviceCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB BACKUP STD Microsoft OneDrive (Acronis)")
     * @unit("unit")
     */
    public $CBBStdO365OneDrive;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB BACKUP STD Servers (Acronis)")
     * @unit("unit")
     */
    public $CBBStdServerCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB BACKUP STD Virtual machines (Acronis)")
     * @unit("unit")
     */
    public $CBBStdVmCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB BACKUP STD Web hosting servers (Acronis)")
     * @unit("unit")
     */
    public $CBBStdWebHostingServerCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB BACKUP STD Websites (Acronis)")
     * @unit("unit")
     */
    public $CBBStdWebsiteCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB BACKUP STD Workstations (Acronis)")
     * @unit("unit")
     */
    public $CBBStdWorkstationCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB Cloud Storage (Acronis)")
     * @unit("b")
     */
    public $CBStorageUsage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB Reseller's Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $CBServiceProviderHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB Provider's Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $CBAcronisHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB Google Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $CBGoogleHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB Microsoft Azure Hosted Storage (Acronis)")
     * @unit("b")
     */
    public $CBAzureHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("CB Local Storage (Acronis)")
     * @unit("b")
     */
    public $CBLocalStorageUsage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Advanced Pack - Advanced Backup - Servers (Per GB)")
     * @unit("unit")
     */
    public $PgPackAdvBackupServersCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Advanced Pack - Advanced Backup - Servers (Per Workload)")
     * @unit("unit")
     */
    public $PwPackAdvBackupServersCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Advanced Pack - Advanced Backup - Virtual machines (Per GB)")
     * @unit("unit")
     */
    public $PgPackAdvBackupVmsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Advanced Pack - Advanced Backup - Virtual machines (Per Workload)")
     * @unit("unit")
     */
    public $PwPackAdvBackupVmsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Advanced Pack - Advanced Backup - Web hosting servers (Per GB)")
     * @unit("unit")
     */
    public $PgPackAdvBackupWebHostingServersCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Advanced Pack - Advanced Backup - Web hosting servers (Per Workload)")
     * @unit("unit")
     */
    public $PwPackAdvBackupWebHostingServersCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Advanced Pack - Advanced Backup - Workstations (Per GB)")
     * @unit("unit")
     */
    public $PgPackAdvBackupWorkstationsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Advanced Pack - Advanced Backup - Workstations (Per Workload)")
     * @unit("unit")
     */
    public $PwPackAdvBackupWorkstationsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Disaster Recovery (Base) (Per GB)")
     * @unit("unit")
     */
    public $PgBaseDrBase;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Cloud servers (Per GB)")
     * @unit("unit")
     */
    public $PgBaseAdvDrCloudServersCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Compute points (Per GB)")
     * @unit("item-h")
     */
    public $PgBaseAdvDrComputePoints;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Internet access (Per GB)")
     * @unit("unit")
     */
    public $PgBaseAdvDrInternetAccess;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Public IP addresses (Per GB)")
     * @unit("unit")
     */
    public $PgBaseAdvDrPublicIpsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Disaster Recovery (Base) (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseDrBase;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Advanced Pack - Advanced Management (Per GB)")
     * @unit("unit")
     */
    public $PgPackAdvManagementCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Advanced Pack - Advanced Management (Per Workload)")
     * @unit("unit")
     */
    public $PwPackAdvManagementCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Advanced Pack - Advanced Security (Per GB)")
     * @unit("unit")
     */
    public $PgPackAdvSecurityCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Advanced Pack - Advanced Security (Per Workload)")
     * @unit("unit")
     */
    public $PwPackAdvSecurityCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Workstations (included features) (Per GB)")
     * @unit("unit")
     */
    public $PgBaseSecondaryWorkstationsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Workstations (Per GB)")
     * @unit("unit")
     */
    public $PgBaseWorkstationsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Websites (Per GB)")
     * @unit("unit")
     */
    public $PgBaseWebsitesCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Web hosting servers (included features) (Per GB)")
     * @unit("unit")
     */
    public $PgBaseSecondaryWebHostingServersCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Web hosting servers (Per GB)")
     * @unit("unit")
     */
    public $PgBaseWebHostingServersCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Virtual machines (included features) (Per GB)")
     * @unit("unit")
     */
    public $PgBaseSecondaryVmsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Virtual machines (Per GB)")
     * @unit("unit")
     */
    public $PgBaseVmsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Servers (included features) (Per GB)")
     * @unit("unit")
     */
    public $PgBaseSecondaryServersCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Servers (Per GB)")
     * @unit("unit")
     */
    public $PgBaseServersCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - OneDrive (Per GB)")
     * @unit("unit")
     */
    public $PgBaseM365Onedrive;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Mobile devices (Per GB)")
     * @unit("unit")
     */
    public $PgBaseMobilesCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Microsoft Teams (Per GB)")
     * @unit("unit")
     */
    public $PgBaseM365TeamsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Microsoft SharePoint Online sites (Per GB)")
     * @unit("unit")
     */
    public $PgBaseM365SharepointSitesCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Microsoft Hosted Exchange mailboxes (Per GB)")
     * @unit("unit")
     */
    public $PgBaseHostedExchangeCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Microsoft 365 seats (Per GB)")
     * @unit("unit")
     */
    public $PgBaseM365SeatsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Mailboxes (Per GB)")
     * @unit("unit")
     */
    public $PgBaseM365Mailboxes;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Google Workspace Shared Drive (Per GB)")
     * @unit("unit")
     */
    public $PgBaseGoogleTeamDrive;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Google Workspace seats (Per GB)")
     * @unit("unit")
     */
    public $PgBaseGworkspaceSeatsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Google Drive (Per GB)")
     * @unit("unit")
     */
    public $PgBaseGoogleDrive;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Gmail (incl. Calendar, Contacts) (Per GB)")
     * @unit("unit")
     */
    public $PgBaseGoogleMail;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Cloud servers (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseAdvDrCloudServersCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Workstations (included features) (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseSecondaryWorkstationsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Workstations (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseWorkstationsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Websites (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseWebsitesCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Web hosting servers (included features) (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseSecondaryWebHostingServersCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Web hosting servers (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseWebHostingServersCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Virtual machines (included features) (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseSecondaryVmsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Virtual machines (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseVmsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Servers (included features) (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseSecondaryServersCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Servers (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseServersCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Compute points (Per Workload)")
     * @unit("item-h")
     */
    public $PwBaseAdvDrComputePoints;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - OneDrive (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseM365Onedrive;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Mobile devices (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseMobilesCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Microsoft Teams (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseM365TeamsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Microsoft SharePoint Online sites (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseM365SharepointSitesCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Microsoft Hosted Exchange mailboxes (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseHostedExchangeCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Microsoft 365 seats (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseM365SeatsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Mailboxes (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseM365Mailboxes;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Google Workspace Shared Drive (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseGoogleTeamDrive;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Google Workspace seats (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseGworkspaceSeatsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Google Drive (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseGoogleDrive;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Gmail (incl. Calendar, Contacts) (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseGoogleMail;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Internet access (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseAdvDrInternetAccess;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Public IP addresses (Per Workload)")
     * @unit("unit")
     */
    public $PwBaseAdvDrPublicIpsCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Backup storage (Per GB)")
     * @unit("b")
     */
    public $PgBaseStorageUsage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Service Provider hosted storage (Per GB)")
     * @unit("b")
     */
    public $PgBaseProviderHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Acronis Hosted Storage (Per GB)")
     * @unit("b")
     */
    public $PgBaseAcronisHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Google Hosted Storage (Per GB)")
     * @unit("b")
     */
    public $PgBaseGoogleHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Azure Hosted Storage (Per GB)")
     * @unit("b")
     */
    public $PgBaseAzureHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Disaster recovery storage (Per GB)")
     * @unit("b")
     */
    public $PgBaseAdvDrStorageUsage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Advanced Pack - Disaster Recovery Storage Acronis Hosted (Per GB)")
     * @unit("b")
     */
    public $PgBaseAdvDrAcronisHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Disaster Recovery Service Provider Hosted (Per GB)")
     * @unit("b")
     */
    public $PgBaseAdvDrProviderHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Backup storage (Per Workload)")
     * @unit("b")
     */
    public $PwBaseStorageUsage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Service Provider hosted storage (Per Workload)")
     * @unit("b")
     */
    public $PwBaseProviderHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Acronis Hosted Storage (Per Workload)")
     * @unit("b")
     */
    public $PwBaseAcronisHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Google Hosted Storage (Per Workload)")
     * @unit("b")
     */
    public $PwBaseGoogleHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Azure Hosted Storage (Per Workload)")
     * @unit("b")
     */
    public $PwBaseAzureHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Disaster recovery storage (Per Workload)")
     * @unit("b")
     */
    public $PwBaseAdvDrStorageUsage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Advanced Pack - Disaster Recovery Storage Acronis Hosted (Per Workload)")
     * @unit("b")
     */
    public $PwBaseAdvDrAcronisHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Cyber Protect Cloud - Disaster Recovery Service Provider Hosted (Per Workload)")
     * @unit("b")
     */
    public $PwBaseAdvDrProviderHostedStorage;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Physical Data Shipping - From the cloud")
     * @unit("item-h")
     */
    public $DrivesShippedFromCloudCountItemH;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Physical Data Shipping - To the cloud")
     * @unit("item-h")
     */
    public $DrivesShippedToCloudCountItemH;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Notary - eSignatures (Zero-Trust Consortium)")
     * @unit("item-h")
     */
    public $EsignaturesZTCCount;

    /**
     * @type("http://aps-standard.org/types/core/resource/1.0#Counter")
     * @description("Notary - Notarizations (Zero-Trust Consortium)")
     * @unit("item-h")
     */
    public $NotarizationsZTCCount;

    // scripts_tenant_counter this code is used for code generation, do not remove!

    /**
     * @type(integer)
     */
    public $mspGroupId;

    /**
     * @type(boolean)
     * @title("Is Migration")
     */
    public $ismigration = false;

    /**
     * @type(string)
     */
    public $type;

    /* ======= OTHER PROPERTIES ======= */

    /**
     * @var array
     */
    private $_subscriptionResources;

    /* ======= LAZY PROPERTIES AND  METHODS ======= */

    public function getCounter($counterName)
    {
        if (!isset($this->{$counterName})) {
            $this->{$counterName} = \APS\TypeLibrary::newResourceByTypeId('http://aps-standard.org/types/core/resource/1.0#Counter');
        }

        return $this->{$counterName};
    }

    /* ======= RESOURCE METHODS ======= */

    /**
     * @verb(GET)
     * @path("/allCounters")
     * @return(array)
     */
    public function getAllCountersMap()
    {
        return $this->getAllCounters();
    }

    public function provision()
    {
        $this->accountId = $this->account->id;
        $this->subscriptionId = $this->subscription->subscriptionId;

        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));

        $this->initializeTenantType();

        $this->getTenantStrategy()->provision();

        $this->throwRestAccepted();
    }

    public function provisionAsync()
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        $this->lockCloudOperations(function() {
            $this->getTenantStrategy()->provisionAsync();
        });

        $this->_subscribeToOnTenantAvailableEvent();
    }

    /**
     * @param tenant $new
     */
    public function configure($new)
    {

        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        // We don't use our custom updateCounterLimits() method because in OSA 7.0 it does not work.
        // In OSA 7.0 when configure is called subscription contains resources with old limits.
        parent::configure($new);
        $this->lockCloudOperations(function() use ($new) {
            $this->getTenantStrategy()->configure($new);
        });
    }

    public function unprovision()
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        $this->lockCloudOperations(function() {
            $this->getTenantStrategy()->unprovision();
        });
    }

    /**
     * We define operation for enable
     * @verb(PUT)
     * @path("/enable")
     *
     * @param()
     */
    public function enable()
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        $this->lockCloudOperations(function() {
            $this->getTenantStrategy()->enable();
        });
    }

    /**
     * We define operation for disable
     * @verb(PUT)
     * @path("/disable")
     *
     * @param()
     */
    public function disable()
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        $this->lockCloudOperations(function() {
            $this->getTenantStrategy()->disable();
        });
    }

    public function retrieve()
    {
        try {
            Log::getInstance()->event(Str::format(
                self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
            ));

            $this->resetCountersUsages();

            $this->getTenantStrategy()->retrieve();
        } catch (\Exception $e) {
            Log::getInstance()->error(sprintf('Caught an error during retrieve: "%s".', $e->getMessage()));
        }
    }

    public function upgrade()
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));

        $this->_removeAdmins();

        $this->aps->type = $this->getSelfApsType();
        if (is_null($this->accountId)) {
            $this->accountId = $this->account->id;
        }
        if (is_null($this->subscriptionId)) {
            $this->subscriptionId = $this->subscription->subscriptionId;
        }
        if (is_null($this->type)) {
            $this->initializeTenantType();
        }

        // remove deprecated properties
        if (isset($this->isReseller)) {
            unset($this->isReseller);
        }
        if (isset($this->TENANTID)) {
            unset($this->TENANTID);
        }
        if (isset($this->GROUPPASS)) {
            unset($this->GROUPPASS);
        }
        if (isset($this->branding)) {
            unset($this->branding);
        }
        if (isset($this->unlimitedQuotas)) {
            unset($this->unlimitedQuotas);
        }
        if (isset($this->isExternalGroup)) {
            unset($this->isExternalGroup);
        }
        if (isset($this->storageId)) {
            unset($this->storageId);
        }

        $this->getTenantStrategy()->upgrade();
        $this->unsubscribeFromOnUserAvailableEvent();
    }

    /* ======= RESOURCE EVENTS ======= */

    /**
     * @verb(POST)
     * @path("/onTenantAvailable")
     *
     * @param("http://aps-standard.org/types/core/resource/1.0#Notification",body)
     */
    public function onTenantAvailable($event)
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        $this->getTenantStrategy()->onTenantAvailable($event);
        $this->_unsubscribeFromOnTenantAvailableEvent();
    }

    /**
     * @verb(POST)
     * @path("/onSubscriptionChange")
     *
     * @param("http://aps-standard.org/types/core/resource/1.0#Notification",body)
     */
    public function onSubscriptionChange($event)
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        $this->lockCloudOperations(function() use ($event) {
            $this->getTenantStrategy()->onSubscriptionChange($event);
        });
    }

    /**
     * @verb(POST)
     * @path("/onAccountChange")
     *
     * @param("http://aps-standard.org/types/core/resource/1.0#Notification",body)
     */
    public function onAccountChange($event)
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        $this->getTenantStrategy()->onAccountChange($event);
    }

    /**
     * @verb(POST)
     * @path("/onUserChanged")
     *
     * @param("http://aps-standard.org/types/core/resource/1.0#Notification",body)
     */
    public function onUserChanged($event)
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        $this->getTenantStrategy()->onUserChanged($event);
    }

    /* ======= RESOURCE OPERATIONS ======= */

    /**
     * @verb(POST)
     * @path("/administrators")
     * @param(object,body)
     * @param(object,query)
     */
    public function createAdministrator($parameters, $datacenterId = '')
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        $this->getTenantStrategy()->createAdministrator($parameters, $this->tenantId, $datacenterId);
    }

    /**
     * @verb(GET)
     * @path("/administrators")
     */
    public function getAdministrators()
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        return $this->getTenantStrategy()->getAdministrators();
    }

    /**
     * @verb(GET)
     * @path("/administrators/{adminId}")
     * @param(string,path)
     * @param(string,query)
     *
     * @throws \Rest\RestException
     * @return stdClass
     */
    public function getAdministrator($adminId, $datacenterId = '')
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        return $this->getTenantStrategy()->getAdministrator($adminId, $datacenterId);
    }

    /**
     * @verb(PUT)
     * @path("/administrators/{adminId}")
     * @param(string,path)
     * @param(object,body)
     * @param(string,query)
     *
     * @throws \Rest\RestException
     */
    public function updateAdministrator($adminId, $parameters, $datacenterId = '')
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        $this->getTenantStrategy()->updateAdministrator($adminId, $parameters, $datacenterId);
    }

    /**
     * @verb(DELETE)
     * @path("/administrators/{adminId}")
     * @param(string,path)
     * @param(string,query)
     *
     * @throws \Rest\RestException
     */
    public function deleteAdministrator($adminId, $datacenterId = '')
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        $this->getTenantStrategy()->deleteAdministrator($adminId, $datacenterId);
    }

    /**
     * @verb(GET)
     * @path("/administrators/{adminId}/console")
     * @param(string,path)
     * @param(string,query)
     *
     * @throws \Rest\RestException
     * @return stdClass
     */
    public function getAdministratorConsole($adminId, $datacenterId)
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        return $this->getTenantStrategy()->getAdministratorConsole($adminId, $datacenterId);
    }

    /**
     * @verb(PUT)
     * @path("/administrators/{adminId}/resend")
     * @param(string,path)
     * @param(string,query)
     *
     * @throws \Rest\RestException
     */
    public function resendAdministratorLink($adminId, $datacenterId = '')
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        $this->getTenantStrategy()->resendAdministratorLink($adminId, $datacenterId);
    }

    /**
     * @verb(PUT)
     * @path("/administrators/{adminId}/enable")
     * @param(string,path)
     * @param(string,query)
     *
     * @throws \Rest\RestException
     */
    public function enableAdministrator($adminId, $datacenterId = '')
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        $this->getTenantStrategy()->enableAdministrator($adminId, $datacenterId);
    }

    /**
     * @verb(PUT)
     * @path("/administrators/{adminId}/disable")
     * @param(string,path)
     * @param(string,query)
     *
     * @throws \Rest\RestException
     */
    public function disableAdministrator($adminId, $datacenterId = '')
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        $this->getTenantStrategy()->disableAdministrator($adminId, $datacenterId);
    }

    /**
     * @verb(GET)
     * @path("/administratorGuideLink")
     * @throws Exception
     * @return array
     */
    public function administratorGuideLink()
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));

        return $this->getTenantStrategy()->getUserGuideUrl();
    }

    /**
     * @verb(GET)
     * @path("/redirectUrl")
     * @throws Exception
     * @return array
     */
    public function adminUrlRedirect()
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        return $this->getTenantStrategy()->adminUrlRedirect();
    }

    /**
     * @verb(GET)
     * @path("/updateStatistics")
     * @param()
     */
    public function updateUsageAndLimits()
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        return $this->getTenantStrategy()->updateUsageAndLimits();
    }

    /**
     * @verb(GET)
     * @path("/getDatacenter")
     * @return object
     */
    public function getDatacenter()
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        return $this->getTenantStrategy()->getDatacenter();
    }

    /**
     * @verb(GET)
     * @path("/getDatacenters")
     * @return array
     */
    public function getDatacenters()
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        return $this->getTenantStrategy()->getDatacenters();
    }

    /**
     * @verb(GET)
     * @path("/storages")
     * @return array
     */
    public function getStorages()
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        return $this->getTenantStrategy()->getStorages();
    }

    /**
     * @verb(GET)
     * @path("/plans")
     * @return array
     */
    public function getServicePlans()
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        return $this->getTenantStrategy()->getServicePlans();
    }

    /**
     * @verb(GET)
     * @path("/plans/{planId}")
     * @param(string,path)
     * @return object
     */
    public function getServicePlan($planId)
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        return $this->getTenantStrategy()->getServicePlan($planId);
    }

    /**
     * @verb(PUT)
     * @path("/plans/{planId}")
     * @param(string,path)
     * @param(object,body)
     */
    public function setStorageForPlan($planId, $parameters)
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        $this->getTenantStrategy()->setStorageForPlan($planId, $parameters);
    }

    /**
     * @verb(DELETE)
     * @path("/plans/{planId}")
     * @param(string,path)
     */
    public function unsetStorageForPlan($planId)
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        $this->getTenantStrategy()->unsetStorageForPlan($planId);
    }

    /**
     * @verb(GET)
     * @path("/loginExists")
     *
     * @param(string,query)
     * @param(string,query)
     *
     * @return(boolean)
     */
    public function loginExists($login, $datacenterId = '')
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        Log::getInstance()->event(self::LOG_CALLED_METHOD_WAS_CALLED, __METHOD__);
        return $this->getTenantStrategy()->loginExists($login, $datacenterId);
    }

    /**
     * @verb(GET)
     * @path("/quotasStatistics")
     * @param()
     * @return array
     */
    public function getQuotasStatistics()
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));
        return $this->getTenantStrategy()->getQuotasStatistics();
    }

    /**
     * @verb(POST)
     * @path("/setUsersLicensesAfterUpsell")
     *
     * @param(object,body)
     */
    public function setUsersLicensesAfterUpsell($data)
    {
        Log::getInstance()->event(Str::format(
            self::LOG_METHOD_CALL, $this->aps->id, $this->accountId, $this->subscriptionId, __METHOD__
        ));

        $apsc = $this->_apsc->impersonate($this);
        foreach ($data as $operation => $items) {
            if (!is_array($items)) {
                continue;
            }

            foreach ($items as $item) {
                if (property_exists($item,'notifications') && $item->notifications == []) {
                    // aps removes empty arrays in requests
                    $item->notifications = users::NOTIFICATIONS_EMPTY;
                }
                switch ($operation) {
                    case self::OPERATION_PROVISION_RESOURCE:
                        $method = \APS\Proto::POST;
                        $path = self::APS_2_2_RESOURCES;
                        $resourceData = json_encode($item);
                        break;
                    case self::OPERATION_CONFIGURE_RESOURCE:
                        $method = \APS\Proto::PUT;
                        $path = self::APS_2_2_RESOURCES . $item->aps->id;
                        $resourceData = json_encode($item);
                        break;
                    default:
                        throw new Exception(Str::format(self::EXCEPTION_UNSUPPORTED_OPERATION_MESSAGE, $operation));
                }
                Log::getInstance()->event(self::LOG_EVENT_START_OPERATION, $operation, $method, $path, $resourceData);
                $out = $apsc->getIo()->sendRequest($method, $path, $resourceData);
                Log::getInstance()->event(self::LOG_EVENT_FINISH_OPERATION, $operation, $method, $path, $out);
            }
        }
    }

    /* ======= OTHER METHODS ======= */

    /**
     * @return Model_Resource_TenantInterface
     * @throws Exception
     */
    protected function getTenantStrategy()
    {
        switch ($this->type) {
            case self::TYPE_RESELLER:
                return new Model_Resource_Tenant_Reseller($this, $this->_apsc, $this->_facade, $this->_managerFactory);
            case self::TYPE_PARTNER:
                return new Model_Resource_Tenant_Partner($this, $this->_apsc, $this->_facade, $this->_managerFactory);
            case self::TYPE_CUSTOMER:
                return new Model_Resource_Tenant_Customer($this, $this->_apsc, $this->_facade, $this->_managerFactory);
            default:
                throw new Exception(Str::format('Unsupported type "%s".', $this->type));
        }
    }

    /**
     * @param $tenant
     */
    protected function resetCountersUsages()
    {
        foreach ($this->getCountersManager()->getAllCounters() as $counter) {
            if ($counter->isFake()) {
                continue;
            }

            $counterName = $counter->getName();

            if (!isset($this->{$counterName})) {
                $this->{$counterName} = \APS\TypeLibrary::newResourceByTypeId('http://aps-standard.org/types/core/resource/1.0#Counter');
            }

            $this->{$counterName}->usage = 0;
        }
    }

    /* ----- Common methods -------- */

    /**
     * @return PartnerCredentials
     */
    public function getPartnerCredentials()
    {
        Log::getInstance()->event(self::LOG_CALLED_GET_PARTNER_CREDENTIALS);
        $datacenter = $this->datacenter;
        $credentials = new PartnerCredentials();
        $credentials->baasUrl = $datacenter->url;
        $credentials->partnerLogin = $datacenter->login;
        $credentials->partnerPassword = $datacenter->password;
        return $credentials;
    }

    /**
     * @return string
     */
    protected function getSelfApsType()
    {
        return self::CLOUD_BACKUP_TENANT_TYPE;
    }

    public function checkType()
    {
        if (!in_array($this->type, static::SUPPORTED_TENANT_TYPES)) {
            throw new \RuntimeException(Str::format(
                'Unsupported tenant type "%s".',
                $this->type
            ));
        }
    }

    /**
     * @return users
     */
    public function createUser()
    {
        return new users(
            $this->_facade,
            $this->_managerFactory,
            $this->_sessionStore,
            $this->_apsc
        );
    }

    protected function throwRestAccepted()
    {
        throw new \Rest\Accepted(
            $this,
            Str::format(
                self::EXCEPTION_CREATING_TENANT_MESSAGE,
                $this->account->companyName,
                $this->subscription->subscriptionId
            ),
            self::ASYNC_OPERATION_TIMEOUT
        );
    }

    protected function initializeTenantType()
    {
        if ($this->_isResellerSubscription()) {
            $this->type = self::TYPE_RESELLER;
        } else {
            $apsApi = $this->_getApsApi();
            $profile = $apsApi->getProfile($this->_getSubscriptionResources());
            $this->type = is_null($profile) || $profile->mspGroupType != profile::MSP_GROUP_TYPE_RESELLER ? self::TYPE_CUSTOMER : self::TYPE_PARTNER;
        }
    }

    private function _getSubscriptionResources()
    {
        if (is_null($this->_subscriptionResources)) {
            $this->_subscriptionResources = $this->subscription->resources();
        }
        return $this->_subscriptionResources;
    }

    /**
     * @return bool
     */
    private function _isResellerSubscription()
    {
        $resources = $this->_getSubscriptionResources();
        if (!is_array($resources)) {
            return false;
        }
        foreach ($resources as $res) {
            if (!isset($res->apsType)) {
                continue;
            }
            if ($res->apsType == self::CLOUD_BACKUP_RESELLER_TYPE) {
                return true;
            }
        }
        return false;
    }

    private function _removeAdmins()
    {
        if (!isset($this->admins)) {
            return;
        }
        $admins = $this->admins;
        if (!count($admins)) {
            $admins = $this->_getApsApi()->getAdminsForTenant($this);
        }
        foreach ($admins as $admin) {
            $this->_apsc->unregisterResource($admin);
        }
    }

    private function _subscribeToOnTenantAvailableEvent()
    {
        $eventSubscription = new \APS\EventSubscription(\APS\EventSubscription::Available, self::ON_TENANT_AVAILABLE);
        $this->subscribeOnEventById($eventSubscription, $this->aps->id);
    }

    private function _unsubscribeFromOnTenantAvailableEvent()
    {
        $this->unsubscribeFromEventById(\APS\EventSubscription::Available, $this->aps->id);
    }

    private function unsubscribeFromOnUserAvailableEvent()
    {
        $this->unsubscribeFromEventByType(\APS\EventSubscription::Available, \APS\TypeLibrary::getTypeByServiceId('users'));
    }

    private function lockCloudOperations(callable $method)
    {
        $method();
    }
}
