# Acronis\Cloud\Client\ReportsApi

All URIs are relative to *https://localhost:443/api/2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**deleteReportsByReportId**](ReportsApi.md#deleteReportsByReportId) | **DELETE** /reports/{report_id} | ReportsByReportId
[**getReportsByReportId**](ReportsApi.md#getReportsByReportId) | **GET** /reports/{report_id} | ReportsByReportId
[**getReportsStoredByReportId**](ReportsApi.md#getReportsStoredByReportId) | **GET** /reports/{report_id}/stored | ReportsStoredByReportId
[**getReportsStoredByReportIdAndStoredReportId**](ReportsApi.md#getReportsStoredByReportIdAndStoredReportId) | **GET** /reports/{report_id}/stored/{stored_report_id} | ReportsStoredByReportIdAndStoredReportId
[**postReports**](ReportsApi.md#postReports) | **POST** /reports | Reports
[**postReportsBulk**](ReportsApi.md#postReportsBulk) | **POST** /reports/bulk | ReportsBulk
[**putReportsByReportId**](ReportsApi.md#putReportsByReportId) | **PUT** /reports/{report_id} | ReportsByReportId


# **deleteReportsByReportId**
> deleteReportsByReportId($report_id, $version)

ReportsByReportId

Delete a report by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\ReportsApi();
$report_id = "report_id_example"; // string | 
$version = "version_example"; // string | 

try {
    $api_instance->deleteReportsByReportId($report_id, $version);
} catch (Exception $e) {
    echo 'Exception when calling ReportsApi->deleteReportsByReportId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **report_id** | **string**|  |
 **version** | **string**|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getReportsByReportId**
> \Acronis\Cloud\Client\Model\Reports\Report getReportsByReportId($report_id, $if_modified_since)

ReportsByReportId

Get report by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\ReportsApi();
$report_id = "report_id_example"; // string | 
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getReportsByReportId($report_id, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ReportsApi->getReportsByReportId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **report_id** | **string**|  |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Acronis\Cloud\Client\Model\Reports\Report**](../Model/Reports/Report.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getReportsStoredByReportId**
> \Acronis\Cloud\Client\Model\Reports\Stored\StoredReportParams getReportsStoredByReportId($report_id)

ReportsStoredByReportId

List all stored reports related to this report order

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\ReportsApi();
$report_id = "report_id_example"; // string | 

try {
    $result = $api_instance->getReportsStoredByReportId($report_id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ReportsApi->getReportsStoredByReportId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **report_id** | **string**|  |

### Return type

[**\Acronis\Cloud\Client\Model\Reports\Stored\StoredReportParams**](../Model/Reports/Stored/StoredReportParams.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getReportsStoredByReportIdAndStoredReportId**
> string getReportsStoredByReportIdAndStoredReportId($report_id, $stored_report_id)

ReportsStoredByReportIdAndStoredReportId

Download stored report data

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\ReportsApi();
$report_id = "report_id_example"; // string | 
$stored_report_id = "stored_report_id_example"; // string | 

try {
    $result = $api_instance->getReportsStoredByReportIdAndStoredReportId($report_id, $stored_report_id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ReportsApi->getReportsStoredByReportIdAndStoredReportId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **report_id** | **string**|  |
 **stored_report_id** | **string**|  |

### Return type

**string**

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postReports**
> \Acronis\Cloud\Client\Model\Reports\Report postReports($body)

Reports

Create a new report configuration ((scheduled one-time/monthly)/not scheduled)

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\ReportsApi();
$body = new \Acronis\Cloud\Client\Model\Reports\ReportPost(); // \Acronis\Cloud\Client\Model\Reports\ReportPost | 

try {
    $result = $api_instance->postReports($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ReportsApi->postReports: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Acronis\Cloud\Client\Model\Reports\ReportPost**](../Model/Reports/ReportPost.md)|  |

### Return type

[**\Acronis\Cloud\Client\Model\Reports\Report**](../Model/Reports/Report.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postReportsBulk**
> \Acronis\Cloud\Client\Model\Reports\Bulk postReportsBulk($body)

ReportsBulk

Create a new report configuration for a bulk of tenants

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\ReportsApi();
$body = new \Acronis\Cloud\Client\Model\Reports\BulkPost(); // \Acronis\Cloud\Client\Model\Reports\BulkPost | 

try {
    $result = $api_instance->postReportsBulk($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ReportsApi->postReportsBulk: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Acronis\Cloud\Client\Model\Reports\BulkPost**](../Model/Reports/BulkPost.md)|  |

### Return type

[**\Acronis\Cloud\Client\Model\Reports\Bulk**](../Model/Reports/Bulk.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **putReportsByReportId**
> \Acronis\Cloud\Client\Model\Reports\Report putReportsByReportId($report_id, $body)

ReportsByReportId

Update a report by ID (only scheduled reports).

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\ReportsApi();
$report_id = "report_id_example"; // string | 
$body = new \Acronis\Cloud\Client\Model\Reports\ReportPut(); // \Acronis\Cloud\Client\Model\Reports\ReportPut | 

try {
    $result = $api_instance->putReportsByReportId($report_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ReportsApi->putReportsByReportId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **report_id** | **string**|  |
 **body** | [**\Acronis\Cloud\Client\Model\Reports\ReportPut**](../Model/Reports/ReportPut.md)|  |

### Return type

[**\Acronis\Cloud\Client\Model\Reports\Report**](../Model/Reports/Report.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

