**Code generation tool**

###### Why it is needed? 

- APS package requires presence of some meta information in dedicated format (annotation and special fields in ``tenant.php``)
- UI requires namings of all offering items for i18n (it is located in ``common.js`)
- Old working implementation of setting up counters after package installation requires ``resources.json`` as well

So, instead of one YAML definition we have at least
3 lists in parallel with high risk of inconsistencies and many time to prepare huge amount
of offering items from requirements to source code level of implementation.

That is why it is automated.

###### List of features

- is generating all offering items/counters code from offering_items_list.yaml
 during package build in docker
- can support code generation for multiple integrations, currently supports only ``public_aps``

###### Main structure of project and short configuration howto

- templates for code generation are located under ``templates/{integration_name}``
-  there is a file ``mapping.yaml`` under each folder with templates which defines 
  relation between file + (multiple) placeholder in it and template which will be used per each 
  offering item to generate source code.
- outputs interpolated (linear) file with all applied mapping and usage aggregation schemes
to offering_items_list_interpolated.yaml

###### For future

- see doc/.placeholder for ideas of documenting
- feel free to add PHPUnit tests to cover most critical parts of this tool to tests
- feel free to actualize templates when you do some changes which affect lines of code around comment
```" this code is used for code generation, do not remove!"``` 