<?php
/**
 * @Copyright © 2002-2020 Acronis International GmbH. All rights reserved
 */

namespace Acronis\Common\CodeGenerator\Validators;

use Doctrine\Common\Annotations\AnnotationRegistry;
use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Component\Validator\Constraints\Choice;
use Symfony\Component\Validator\Mapping\ClassMetadata;
use Symfony\Component\Validator\Constraints\ChoiceValidator;
use Composer\Autoload\ClassLoader;
use Symfony\Component\Validator\Validation;

class OfferingItemValidator extends AbstractValidator
{
    /**
     * @Assert\NotBlank
     * @Assert\Regex(pattern="/^([\da-z_]*)$/", message="Offering item name {{ value }} is not valid.")
     */
    protected $name;

    /**
     * @Assert\NotBlank
     * @Assert\Regex(pattern="/^([\da-z_]*)$/", message="Usage  type {{ value }} is not valid.")
     */
    protected $usage_type;

    /**
     * @Assert\NotBlank
     */
    protected $application;

    /**
     * @Assert\Regex(pattern="/^(count|feature|storage|ranged|ranged_count)$/", message="Offering item type {{ value }} is not supported.")
     */
    protected $type;

    /**
     * Can be blank
     * @Assert\Regex(pattern="/^(i\-[\da-z\-]*)$/", message="Offering item icon class {{ value }} is not valid, should be like i-{something-like-oi-name}.")
     */
    protected $icon;

    /**
     * @Assert\NotBlank
     */
    protected $counter_title;
}